package com.bytesw.bytebot.controller.airport;

import com.bytesw.bytebot.dto.AeropuertoDTO;
import com.bytesw.bytebot.dto.DataPage;
import com.bytesw.bytebot.service.aeropuerto.AeropuertoServiceImpl;
import com.bytesw.xdf.controller.BasicXDFController;
import com.bytesw.xdf.controller.XDFController;
import com.bytesw.xdf.sql.beans.Pagination;
import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import io.swagger.annotations.ApiResponse;
import io.swagger.annotations.ApiResponses;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;

@RestController
@RequestMapping("/service/aeropuerto")
public class AeropuertoController extends BasicXDFController<AeropuertoDTO,Integer> {

    @Autowired
    private AeropuertoServiceImpl aeropuertoService;

    @Autowired
    private GsonBuilder gsonBuilder;

    public AeropuertoController(AeropuertoServiceImpl aeropuertoService){
        super(aeropuertoService);
    }

    public ResponseEntity<String> findAllByPagination(@RequestBody Pagination<AeropuertoDTO> pagination) {
        Gson gson = gsonBuilder.create();
        DataPage<AeropuertoDTO> value = new DataPage<>();
        value.setData(aeropuertoService.getAll());
        return new ResponseEntity(value, HttpStatus.OK);
    }

}
