package com.bytesw.bytebot.controller.airport;

import com.bytesw.bytebot.dto.DataPage;
import com.bytesw.bytebot.dto.ItinerarioReservaDTO;
import com.bytesw.bytebot.dto.PasajeroDTO;
import com.bytesw.bytebot.service.ItinerarioReservaServiceImpl;
import com.bytesw.bytebot.service.PasajeroServiceImpl;
import com.bytesw.xdf.controller.BasicXDFController;
import com.bytesw.xdf.sql.beans.Pagination;
import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.servlet.http.HttpServletRequest;

@RestController
@RequestMapping("/service/itinerarios")
public class ItinerarioReservaController extends BasicXDFController<ItinerarioReservaDTO,Integer> {

    @Autowired
    private ItinerarioReservaServiceImpl itinerarioReservaService;

    @Autowired
    private GsonBuilder gsonBuilder;

    public ItinerarioReservaController(ItinerarioReservaServiceImpl itinerarioReservaService){
        super(itinerarioReservaService);
    }

    public ResponseEntity<String> findAllByPagination(@RequestBody Pagination<ItinerarioReservaDTO> pagination) {
        Gson gson = gsonBuilder.create();
        DataPage<ItinerarioReservaDTO> value = new DataPage<>();
        value.setData(itinerarioReservaService.getAll());
        return new ResponseEntity(value, HttpStatus.OK);
    }

    public ResponseEntity<String> findAll(HttpServletRequest req) {
        return new ResponseEntity(this.itinerarioReservaService.getAll(), HttpStatus.OK);
    }

    public ResponseEntity<String> findOne(@PathVariable("id") Integer id, HttpServletRequest req) {
        return new ResponseEntity(this.itinerarioReservaService.getById(id), HttpStatus.OK);
    }
}
