package com.bytesw.bytebot.model.airport;

import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.google.gson.annotations.Expose;
import lombok.Getter;
import lombok.Setter;

import javax.persistence.*;
import java.io.Serializable;
import java.util.Date;
import java.util.List;

@Entity
@Table(name="legs")
@Getter
@Setter
public class Escala implements Serializable {
    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    private Integer id;

    @Column(name="actual_departure_time")
    @Temporal(TemporalType.TIMESTAMP)
    private Date fechaSalida;

    @Column(name="actual_arrival_time")
    @Temporal(TemporalType.TIMESTAMP)
    private Date fechaLlegada;

    @ManyToOne(fetch = FetchType.LAZY, optional = false)
    @JoinColumn(name = "origin_airport_code")
    @JsonProperty(access = JsonProperty.Access.WRITE_ONLY)
    private Aeropuerto codigoAeropuertoOrigen;

    @ManyToOne(fetch = FetchType.LAZY, optional = false)
    @JoinColumn(name = "destination_airport_code")
    @JsonProperty(access = JsonProperty.Access.WRITE_ONLY)
    private Aeropuerto codigoAeropuertoDestino;

    @ManyToOne(fetch = FetchType.LAZY, optional = false)
    @JoinColumn(name = "flight_number")
    @JsonProperty(access = JsonProperty.Access.WRITE_ONLY)
    private Vuelo codigoVuelo;

    @ManyToMany(fetch = FetchType.LAZY,
            cascade = {
                    CascadeType.PERSIST,
                    CascadeType.MERGE,
                    CascadeType.ALL
            },
            mappedBy = "escalas")
    @JsonIgnore
    private List<ItinerarioReserva> itinerarioReserva;


}
