package com.bytesw.bytebot.model.airport;

import com.fasterxml.jackson.annotation.JsonIgnore;
import lombok.EqualsAndHashCode;
import lombok.Getter;
import lombok.Setter;
import lombok.ToString;

import javax.persistence.*;
import java.io.Serializable;
import java.util.Date;
import java.util.List;

@Entity
@Table(name="payments")
@Getter
@Setter
@EqualsAndHashCode
@ToString
public class Pago implements Serializable {
    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    @Column(name = "payment_id")
    private Integer id;

    @Column(name="payment_date")
    @Temporal(TemporalType.TIMESTAMP)
    private Date fecha;

    @Column(name="payment_amount")
    private double pago;

    @Column(name="payment_status_code")
    private String estado;

    @ManyToMany(fetch = FetchType.LAZY,
            cascade = {
                    CascadeType.PERSIST,
                    CascadeType.MERGE,
                    CascadeType.ALL
            },
            mappedBy = "pagos")
    @JsonIgnore
    private List<ItinerarioReserva> itinerarioReserva;

    @PrePersist
    public void prePersist(){
        fecha = new java.util.Date();
    }

}
