package com.bytesw.bytebot.model.airport;

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import lombok.*;

import javax.persistence.*;
import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;

@Entity
@Table(name="passengers")
@Getter
@Setter



public class Pasajero implements Serializable {
    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    @Column(name="id")
    private Integer id;

    @Column(name="first_name")
    private String primerNombre;

    @Column(name="second_name")
    private String segundoNombre;

    @Column(name="last_name")
    private String apellido;

    @Column(name="phone_number")
    private String telefono;

    @Column(name="email_address")
    private String correo;

    @Column(name="address_lines")
    private String direccion;

    @Column(name="city")
    private String ciudad;

    @Column(name="state_province_country")
    private String provincia;

    @Column(name="country")
    private String pais;

    @Column(name="other_passenger_details")
    private String detalles;

    @OneToMany(mappedBy = "pasajero")
    private List<ItinerarioReserva> itinerarioReservas = new ArrayList<>();

}
