package com.bytesw.bytebot.model.airport;

import com.fasterxml.jackson.annotation.JsonBackReference;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonProperty;
import lombok.EqualsAndHashCode;
import lombok.Getter;
import lombok.Setter;
import lombok.ToString;
import org.springframework.format.annotation.DateTimeFormat;

import javax.persistence.*;
import java.io.Serializable;
import java.util.Date;
import java.util.List;

@Entity
@Table(name="flight_schedules")
@Getter
@Setter
@EqualsAndHashCode
@ToString
public class Vuelo implements Serializable {
    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    private Integer id;

    @Column(name="flight_cost")
    private double costo;

    @Column(name="airline_code")
    private String codigoAerolinea;

    @Column(name="usual_aircraft_type_code")
    private String codigoTipoAeronave;

    @Column(name="departure_date_time")
    @Temporal(TemporalType.TIMESTAMP)
    private Date fechaSalida;

    @Column(name="arrival_date_time")
    @Temporal(TemporalType.TIMESTAMP)
    @DateTimeFormat(pattern = "yyyy-MM-dd")
    private Date fechaLlegada;

    @ManyToOne(fetch = FetchType.LAZY, optional = false)
    @JoinColumn(name = "origin_airport_code")
    @JsonProperty(access = JsonProperty.Access.WRITE_ONLY)
    private Aeropuerto codigoAeropuertoOrigen;

    @ManyToOne(fetch = FetchType.LAZY, optional = false)
    @JoinColumn(name = "destination_airport_code")
    @JsonProperty(access = JsonProperty.Access.WRITE_ONLY)
    private Aeropuerto codigoAeropuertoDestino;

    @OneToMany(mappedBy = "codigoVuelo", cascade = CascadeType.ALL)
    private List<Escala> escalas;

}
