package com.bytesw.bytebot.service;

import com.bytesw.bytebot.dto.AgenteReservaDTO;
import com.bytesw.bytebot.dto.PasajeroDTO;
import com.bytesw.bytebot.model.airport.AgenteReserva;
import com.bytesw.bytebot.model.airport.Pasajero;
import com.bytesw.bytebot.repository.IAgenteDAO;
import com.bytesw.bytebot.repository.IPasajeroDAO;
import com.bytesw.xdf.service.XDFService;
import org.springframework.beans.BeanUtils;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;


@Service
@Transactional
public class AgenteServiceImpl extends XDFService<AgenteReserva, AgenteReservaDTO,Integer> {
    protected AgenteServiceImpl(IAgenteDAO agenteDAO){
        super(agenteDAO);
    }

    @Override
    protected AgenteReservaDTO toBean(AgenteReserva model){
        AgenteReservaDTO bean = new AgenteReservaDTO();
        BeanUtils.copyProperties(model,bean);
        return bean;
    }

    @Override
    protected AgenteReserva toModel(AgenteReserva model, AgenteReservaDTO bean){
        if(model == null){
            model = new AgenteReserva();
        }
        BeanUtils.copyProperties(bean,model);
        return model;
    }
}
