package com.bytesw.bytebot.service;

import com.bytesw.bytebot.dto.AeropuertoDTO;
import com.bytesw.bytebot.dto.EscalaDTO;
import com.bytesw.bytebot.dto.VueloDTO;
import com.bytesw.bytebot.model.airport.Aeropuerto;
import com.bytesw.bytebot.model.airport.Escala;
import com.bytesw.bytebot.model.airport.Vuelo;
import com.bytesw.bytebot.repository.IEscalaDAO;
import com.bytesw.bytebot.service.aeropuerto.AeropuertoServiceImpl;
import com.bytesw.xdf.service.XDFService;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

@Service
@Transactional
public class EscalaServiceImpl extends XDFService<Escala, EscalaDTO,Integer> {
        @Autowired
        private VueloServiceImpl vueloService;
        @Autowired
        private AeropuertoServiceImpl aeropuertoService;

        protected EscalaServiceImpl(IEscalaDAO escalaDAO){
        super(escalaDAO);
        }

        @Override
        protected EscalaDTO toBean(Escala model){
                EscalaDTO bean = new EscalaDTO();
                BeanUtils.copyProperties(model,bean);
                bean.setCodigoAeropuertoOrigen(model.getCodigoAeropuertoOrigen().getId());
                bean.setCodigoAeropuertoDestino(model.getCodigoAeropuertoDestino().getId());
                bean.setAeropuertoOrigen(model.getCodigoAeropuertoOrigen().getCodigo());
                bean.setAeropuertoDestino(model.getCodigoAeropuertoDestino().getCodigo());
        return bean;
        }

        @Override
        protected Escala toModel(Escala model, EscalaDTO bean){
        if(model == null){
                model = new Escala();
                }
                BeanUtils.copyProperties(bean,model);
                VueloDTO vueloDTO = vueloService.getById(bean.getCodigoVuelo());
                model.setCodigoVuelo(vueloService.toModel(new Vuelo(),vueloDTO));
                AeropuertoDTO aeropuertoDTO = aeropuertoService.getById(bean.getCodigoAeropuertoOrigen());
                AeropuertoDTO aeropuertoDTO2 = aeropuertoService.getById(bean.getCodigoAeropuertoDestino());
                model.setCodigoAeropuertoOrigen(aeropuertoService.toModel(new Aeropuerto(),aeropuertoDTO));
                model.setCodigoAeropuertoDestino(aeropuertoService.toModel(new Aeropuerto(), aeropuertoDTO2));
        return model;
        }

}
