package com.bytesw.bytebot.service;

import com.bytesw.bytebot.dto.*;
import com.bytesw.bytebot.model.airport.*;
import com.bytesw.bytebot.repository.IItinerarioReservaDAO;
import com.bytesw.bytebot.service.aeropuerto.AeropuertoServiceImpl;
import com.bytesw.xdf.service.XDFService;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;


@Service
@Transactional
public class ItinerarioReservaServiceImpl extends XDFService<ItinerarioReserva, ItinerarioReservaDTO,Integer> {

    @Autowired
    private PasajeroServiceImpl pasajeroService;

    @Autowired
    private AgenteServiceImpl agenteService;

    protected ItinerarioReservaServiceImpl(IItinerarioReservaDAO iItinerarioReservaDAO){
        super(iItinerarioReservaDAO);
    }

    @Override
    protected ItinerarioReservaDTO toBean(ItinerarioReserva model){
        ItinerarioReservaDTO bean = new ItinerarioReservaDTO();
        BeanUtils.copyProperties(model,bean);
        bean.setCodigoPasajero(model.getPasajero().getId());
        bean.setCodigoAgente(model.getAgente().getId());
        return bean;
    }

    @Override
    protected ItinerarioReserva toModel(ItinerarioReserva model, ItinerarioReservaDTO bean){
        if(model == null){
        model = new ItinerarioReserva();
        }
        BeanUtils.copyProperties(bean,model);
        PasajeroDTO pasajeroDTO = pasajeroService.getById(bean.getCodigoPasajero());
        AgenteReservaDTO agenteReservaDTO = agenteService.getById(bean.getCodigoAgente());
        model.setPasajero(pasajeroService.toModel(new Pasajero(),pasajeroDTO));
        model.setAgente(agenteService.toModel(new AgenteReserva(), agenteReservaDTO));
        return model;
    }


}