package com.bytesw.bytebot.service;

import com.bytesw.bytebot.dto.AgenteReservaDTO;
import com.bytesw.bytebot.dto.PagoDTO;
import com.bytesw.bytebot.dto.PasajeroDTO;
import com.bytesw.bytebot.model.airport.AgenteReserva;
import com.bytesw.bytebot.model.airport.Pago;
import com.bytesw.bytebot.model.airport.Pasajero;
import com.bytesw.bytebot.repository.IPagoDAO;
import com.bytesw.bytebot.repository.IPasajeroDAO;
import com.bytesw.xdf.service.XDFService;
import org.springframework.beans.BeanUtils;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

@Service
@Transactional
public class PagoServiceImpl extends XDFService<Pago, PagoDTO,Integer> {

    protected PagoServiceImpl(IPagoDAO pagoDAO){
        super(pagoDAO);
    }

    @Override
    protected PagoDTO toBean(Pago model){
        PagoDTO bean = new PagoDTO();
        BeanUtils.copyProperties(model,bean);
        return bean;
    }

    @Override
    protected Pago toModel(Pago model, PagoDTO bean){
        if(model == null){
            model = new Pago();
        }
        BeanUtils.copyProperties(bean,model);
        return model;
    }
}
