package com.bytesw.bytebot.service.aeropuerto;

import com.bytesw.bytebot.dto.AeropuertoDTO;
import com.bytesw.bytebot.model.airport.Aeropuerto;
import com.bytesw.bytebot.repository.IAeropuertoDAO;
import com.bytesw.bytebot.service.CustomPaginationService;
import com.bytesw.xdf.service.XDFService;
import com.bytesw.xdf.sql.beans.Pagination;
import lombok.extern.log4j.Log4j2;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import org.springframework.transaction.annotation.Transactional;


@Service
@Transactional
public class AeropuertoServiceImpl extends XDFService<Aeropuerto, AeropuertoDTO,Integer>{

    protected AeropuertoServiceImpl(IAeropuertoDAO aeropuertoDAO){
        super(aeropuertoDAO);
    }

    @Override
    protected AeropuertoDTO toBean(Aeropuerto model){
        AeropuertoDTO bean = new AeropuertoDTO();
        BeanUtils.copyProperties(model,bean);
        return bean;
    }

    @Override
    public Aeropuerto toModel(Aeropuerto model, AeropuertoDTO bean){
        if(model == null){
            model = new Aeropuerto();
        }
        BeanUtils.copyProperties(bean,model);
        return model;
    }

}
